{******************************************************************}
{ part of DSPack 1.05                                                     }
{                                                                  }
{ home page : http://www.progdigy.com                              }
{ email     : hgourvest@progdigy.com                               }
{                                                                  }
{ date      : 20-11-2001                                           }
{                                                                  }
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{ *****************************************************************}

unit DSUtil;

interface

uses Windows, Messages, Graphics, ActiveX, Sysutils, DirectShow,MMSystem,
     DirectSound, Controls, classes;

const
  WM_GRAPHNOTIFY = WM_APP + 1;      // Filter Graph Event
  IID_IPropertyBag          : TGUID = '{55272A00-42CB-11CE-8135-00AA004BB851}';
  IID_ISpecifyPropertyPages : TGUID = '{B196B28B-BAB4-101A-B69C-00AA00341D07}';
  MEDIASUBTYPE_MP42         : TGUID = '{3234504D-0000-0010-8000-00AA00389B71}'; // MS Mepg4 DMO
  MEDIASUBTYPE_DIVX         : TGUID = '{58564944-0000-0010-8000-00AA00389B71}'; // DIVX
  MEDIASUBTYPE_VOXWARE      : TGUID = '{00000075-0000-0010-8000-00AA00389B71}'; // VoxWare MetaSound
  IID_IPersistStream        : TGUID = '{00000109-0000-0000-C000-000000000046}';
  IID_IMoniker              : TGUID = '{0000000F-0000-0000-C000-000000000046}';
  
type
  TOverlayColor = record
    case integer of
      0:(low   : cardinal;
         hight : cardinal);
      1:(color : TColor);
    end;

  TFilePath =  array[0..MAX_PATH] of WChar;

// User OPerationS
  TDSUOPSFlag = (
    SelectVideoModePreference,
    PlayTitleOrAtTime,
    PlayChapter,
    PlayTitle,
    Stop,
    ReturnFromSubMenu,
    PlayChapterOrAtTime,
    PlayPrevOrReplayChapter,
    PlayNextChapter,
    PlayForwards,
    PlayBackwards,
    ShowMenuTitle,
    ShowMenuRoot,
    ShowMenuSubPic,
    ShowMenuAudio,
    ShowMenuAngle,
    ShowMenuChapter,
    CanResume,
    SelectOrActivateButton,
    CanStillOff,
    CanPauseOn,
    SelectAudioStream,
    SelectSubPicStream,
    SelectAngle,
    SelectKaraokeAudioPresentationMode

  );

  TDSUOPSKind = set of TDSUOPSFlag;

  TUOPS =  record
    TitlePlay                         : boolean; //2   Finds the media file with the specified title index and plays it back.
    ChapterPlay                       : boolean; //1   Plays the media file with the specified title index and chapter value.
    TimePlay                          : boolean; //0   Plays the media file with the specified title index, starting at the specified time.
    StopForResume                     : boolean; //3   Transitions playback to the DVD_DOMAIN_Stop state after saving resume information.
    GoUp                              : boolean; //4   Halts playback of the current media file and starts playback of the designated previous program chain (PGC).
    TimeSearch                        : boolean; //0,5 Halts playback of the current chapter and starts playback from the specified time in the same media file.
    ChapterSearch                     : boolean; //1,5 Halts playback of the current chapter and starts playback from the specified chapter value in the same media file.
    PrevPGSearch                      : boolean; //6   Halts playback of the current program and starts playback from the previous program within the program chain (PGC).
    TopPGSearch                       : boolean; //6   Halts playback of the current program and restarts playback of the current program within the program chain (PGC).
    NextPGSearch                      : boolean; //7   Halts playback of the current program and starts playback from the next program within the program chain (PGC).
    ForwardScan                       : boolean; //8   Search forward through the current disc at the specified speed.
    BackwardScan                      : boolean; //9   Search backward through the current disc at the specified speed.
    MenuCall_Title_Menu               : boolean; //10  Displays the specified menu on the screen.
    MenuCall_Root_Menu                : boolean; //11
    MenuCall_Sub_picture_Menu         : boolean; //12
    MenuCall_Audio_Menu               : boolean; //13
    MenuCall_Angle_Menu               : boolean; //14
    MenuCall_Chapter_Menu             : boolean; //15
    Resume                            : boolean; //16  Returns to playing back a title from a menu.
    UpperButtonSelect                 : boolean; //17  Selects the upper directional button from the displayed menu.
    LowerButtonSelect                 : boolean; //17  Selects the lower directional button from the displayed menu.
    LeftButtonSelect                  : boolean; //17  Selects the left directional button from the displayed menu.
    RightButtonSelect                 : boolean; //17  Selects the right directional button from the displayed menu.
    ButtonActivate                    : boolean; //17  Activates the selected button.
    ButtonSelectAndActivate           : boolean; //17  Selects and activates the specified button.
    StillOff                          : boolean; //18  Resumes playback, cancelling still mode.
    PauseOn                           : boolean; //19  Pauses the current media file playback.
    PauseOff                          : boolean; //19  Unpauses the current media file playback.
    AudioStreamChange                 : boolean; //20  Sets the current audio stream.
    SubpictureStreamChange            : boolean; //21  Enables or disables picture-in-picture mode and sets the subpicture to the specified source.
    AngleChange                       : boolean; //22  Sets the new display angle.
    KaraokeAudioPresentationModeChange: boolean; //23  Sets the audio playback mode to karaoke.
    VideoModePreferrence              : boolean; //24  Sets the video display mode the user prefers.
  end;

  TDSAMSeeking = (
    CanSeekAbsolute,
    CanSeekForwards,
    CanSeekBackwards,
    CanGetCurrentPos,
    CanGetStopPos,
    CanGetDuration,
    CanPlayBackwards,
    CanDoSegments,
    Source
  );
  TDSAMSeekingKind = set of TDSAMSeeking;

  function FileToPath(FileName: string): TFilePath;
  function GetEventCodeDef(code: longint): string;
  function IntToBin(Value: LongInt; Digits: Integer): String;
  function IntToUOPS(value : longint):TUOPS;
  function IntToTimeCode(x : longint): TDVD_TimeCode;
  function BinToInt(Value: String): LongInt;
  function TimeCodeToFrames(value : TDVD_TimeCode): ULONG;
  function ShowFilterPropertyPage(parent: TWinControl; Filter: IBaseFilter): HRESULT;
  function ShowPinPropertyPage(parent: TWinControl; Pin: IPin): HRESULT;
  function AddGraphToRot(Graph: IFilterGraph; out dwRegister: Longint): HRESULT;
  function RemoveGraphFromRot(dwRegister: longint): HRESULT;
  function GetErrorString(hr: HRESULT): string;
  function GetFOURCC(FOURCC: DWORD): string;
  function GetMediaTypeDescription(MediaType: TAM_Media_Type): string;

  // General purpose functions to copy and delete a task allocated AM_MEDIA_TYPE
  // structure which is useful when using the IEnumMediaFormats interface as
  // the implementation allocates the structures which you must later delete
  procedure DeleteMediaType(pmt: PAM_MEDIA_TYPE);
  function  CreateMediaType(pSrc: PAM_MEDIA_TYPE): PAM_MEDIA_TYPE;
  procedure CopyMediaType(pmtTarget: PAM_MEDIA_TYPE; pmtSource: PAM_MEDIA_TYPE);
  procedure FreeMediaType(mt: PAM_MEDIA_TYPE);

  //  Initialize a media type from a WAVEFORMATEX
  function CreateAudioMediaType(pwfx: PWaveFormatEx; pmt: PAM_MEDIA_TYPE; bSetFormat: boolean): HRESULT;
  function FOURCCMap(Fourcc: DWORD): TGUID;

  procedure FreeAndNil(var Obj); // Delphi4 compatibility
  function MAKEFOURCC(ch0, ch1, ch2, ch3: char): DWORD;

  function PersistToHex(obj: IPersistStream): string;
  function HexToPersist(str: String; GUID: TGUID): IPersistStream;
  
implementation

  function  FileToPath(FileName: string): TFilePath;
  begin
    MultiByteToWideChar(CP_ACP,0,Pchar(FileName),-1,result,Sizeof(result) div sizeof(result[0]));
  end;

  function  GetEventCodeDef(code: longint): string;
  begin
    case code of
      EC_ACTIVATE                  : result:= 'EC_ACTIVATE - A video window is being activated or deactivated.';
      EC_BUFFERING_DATA            : result:= 'EC_BUFFERING_DATA - The graph is buffering data, or has stopped buffering data.';
      EC_CLOCK_CHANGED             : result:= 'EC_CLOCK_CHANGED - The reference clock has changed.';
      EC_COMPLETE                  : result:= 'EC_COMPLETE - All data from a particular stream has been rendered.';
      EC_DEVICE_LOST               : result:= 'EC_DEVICE_LOST - A Plug and Play device was removed or has become available again.';
      EC_DISPLAY_CHANGED           : result:= 'EC_DISPLAY_CHANGED - The display mode has changed.';
      EC_END_OF_SEGMENT            : result:= 'EC_END_OF_SEGMENT - The end of a segment has been reached.';
      EC_ERROR_STILLPLAYING        : result:= 'EC_ERROR_STILLPLAYING - An asynchronous command to run the graph has failed.';
      EC_ERRORABORT                : result:= 'EC_ERRORABORT - An operation was aborted because of an error.';
      EC_FULLSCREEN_LOST           : result:= 'EC_FULLSCREEN_LOST - The video renderer is switching out of full-screen mode.';
      EC_GRAPH_CHANGED             : result:= 'EC_GRAPH_CHANGED - The filter graph has changed.';
      EC_NEED_RESTART              : result:= 'EC_NEED_RESTART - A filter is requesting that the graph be restarted.';
      EC_NOTIFY_WINDOW             : result:= 'EC_NOTIFY_WINDOW - Notifies a filter of the video renderer''s window.';
      EC_OLE_EVENT                 : result:= 'EC_OLE_EVENT - A filter is passing a text string to the application.';
      EC_OPENING_FILE              : result:= 'EC_OPENING_FILE - The graph is opening a file, or has finished opening a file.';
      EC_PALETTE_CHANGED           : result:= 'EC_PALETTE_CHANGED - The video palette has changed.';
      EC_PAUSED                    : result:= 'EC_PAUSED - A pause request has completed.';
      EC_QUALITY_CHANGE            : result:= 'EC_QUALITY_CHANGE - The graph is dropping samples, for quality control.';
      EC_REPAINT                   : result:= 'EC_REPAINT - A video renderer requires a repaint.';
      EC_SEGMENT_STARTED           : result:= 'EC_SEGMENT_STARTED - A new segment has started.';
      EC_SHUTTING_DOWN             : result:= 'EC_SHUTTING_DOWN - The filter graph is shutting down, prior to being destroyed.';
      EC_SNDDEV_IN_ERROR           : result:= 'EC_SNDDEV_IN_ERROR - An audio device error has occurred on an input pin.';
      EC_SNDDEV_OUT_ERROR          : result:= 'EC_SNDDEV_OUT_ERROR - An audio device error has occurred on an output pin.';
      EC_STARVATION                : result:= 'EC_STARVATION - A filter is not receiving enough data.';
      EC_STEP_COMPLETE             : result:= 'EC_STEP_COMPLETE - A filter performing frame stepping has stepped the specified number of frames.';
      EC_STREAM_CONTROL_STARTED    : result:= 'EC_STREAM_CONTROL_STARTED - A stream-control start command has taken effect.';
      EC_STREAM_CONTROL_STOPPED    : result:= 'EC_STREAM_CONTROL_STOPPED - A stream-control start command has taken effect.';
      EC_STREAM_ERROR_STILLPLAYING : result:= 'EC_STREAM_ERROR_STILLPLAYING - An error has occurred in a stream. The stream is still playing.';
      EC_STREAM_ERROR_STOPPED      : result:= 'EC_STREAM_ERROR_STOPPED - A stream has stopped because of an error.';
      EC_USERABORT                 : result:= 'EC_USERABORT - The user has terminated playback.';
      EC_VIDEO_SIZE_CHANGED        : result:= 'EC_VIDEO_SIZE_CHANGED - The native video size has changed.';
      EC_WINDOW_DESTROYED          : result:= 'EC_WINDOW_DESTROYED - The video renderer was destroyed or removed from the graph.';
      EC_TIMECODE_AVAILABLE        : result:= 'EC_TIMECODE_AVAILABLE- Sent by filter supporting timecode';
      EC_EXTDEVICE_MODE_CHANGE     : result:= 'EC_EXTDEVICE_MODE_CHANGE - Sent by filter supporting IAMExtDevice';
      EC_CLOCK_UNSET               : result:= 'EC_CLOCK_UNSET - notify the filter graph to unset the current graph clock';
      EC_TIME                      : result:= 'EC_TIME - The requested reference time occurred (currently not used)';

      EC_DVD_ANGLE_CHANGE              : result:= 'EC_DVD_ANGLE_CHANGE - Signals that either the number of available angles changed or that the current angle number changed.';
      EC_DVD_ANGLES_AVAILABLE          : result:= 'EC_DVD_ANGLES_AVAILABLE - Indicates whether an angle block is being played and angle changes can be performed.';
      EC_DVD_AUDIO_STREAM_CHANGE       : result:= 'EC_DVD_AUDIO_STREAM_CHANGE - Signals that the current audio stream number changed for the main title.';
      EC_DVD_BUTTON_AUTO_ACTIVATED     : result:= 'EC_DVD_BUTTON_AUTO_ACTIVATED - Signals that a menu button has been automatically activated per instructions on the disc.';
      EC_DVD_BUTTON_CHANGE             : result:= 'EC_DVD_BUTTON_CHANGE - Signals that either the number of available buttons changed or that the currently selected button number changed.';
      EC_DVD_CHAPTER_AUTOSTOP          : result:= 'EC_DVD_CHAPTER_AUTOSTOP - Indicates that playback stopped as the result of a call to the IDvdControl2::PlayChaptersAutoStop method.';
      EC_DVD_CHAPTER_START             : result:= 'EC_DVD_CHAPTER_START - Signals that the DVD Navigator started playback of a new chapter in the current title.';
      EC_DVD_CMD_START                 : result:= 'EC_DVD_CMD_START - Signals that a particular command has begun.';
      EC_DVD_CMD_END                   : result:= 'EC_DVD_CMD_END - Signals that a particular command has completed.';
      EC_DVD_CURRENT_HMSF_TIME         : result:= 'EC_DVD_CURRENT_HMSF_TIME - Signals the current time in DVD_HMSF_TIMECODE format at the beginning of every VOBU, which occurs every .4 to 1.0 sec.';
      EC_DVD_CURRENT_TIME              : result:= 'EC_DVD_CURRENT_TIME - Signals the beginning of every video object unit (VOBU), a video segment which is 0.4 to 1.0 seconds in length.';
      EC_DVD_DISC_EJECTED              : result:= 'EC_DVD_DISC_EJECTED - Signals that a disc has been ejected from the drive.';
      EC_DVD_DISC_INSERTED             : result:= 'EC_DVD_DISC_INSERTED - Signals that a disc has been inserted into the drive.';
      EC_DVD_DOMAIN_CHANGE             : result:= 'EC_DVD_DOMAIN_CHANGE - Indicates the DVD Navigator''s new domain.';
      EC_DVD_ERROR                     : result:= 'EC_DVD_ERROR - Signals a DVD error condition.';
      EC_DVD_KARAOKE_MODE              : result:= 'EC_DVD_KARAOKE_MODE - Indicates that the Navigator has either begun playing or finished playing karaoke data.';
      EC_DVD_NO_FP_PGC                 : result:= 'EC_DVD_NO_FP_PGC - Indicates that the DVD disc does not have a FP_PGC (First Play Program Chain).';
      EC_DVD_PARENTAL_LEVEL_CHANGE     : result:= 'EC_DVD_PARENTAL_LEVEL_CHANGE - Signals that the parental level of the authored content is about to change.';
      EC_DVD_PLAYBACK_RATE_CHANGE      : result:= 'EC_DVD_PLAYBACK_RATE_CHANGE - Indicates that a playback rate change has been initiated and the new rate is in the parameter.';
      EC_DVD_PLAYBACK_STOPPED          : result:= 'EC_DVD_PLAYBACK_STOPPED - Indicates that playback has been stopped. The DVD Navigator has completed playback of the title and did not find any other branching instruction for subsequent playback.';
      EC_DVD_PLAYPERIOD_AUTOSTOP       : result:= 'EC_DVD_PLAYPERIOD_AUTOSTOP - Indicates that the Navigator has finished playing the segment specified in a call to PlayPeriodInTitleAutoStop.';
      EC_DVD_STILL_OFF                 : result:= 'EC_DVD_STILL_OFF - Signals the end of any still.';
      EC_DVD_STILL_ON                  : result:= 'EC_DVD_STILL_ON - Signals the beginning of any still.';
      EC_DVD_SUBPICTURE_STREAM_CHANGE  : result:= 'EC_DVD_SUBPICTURE_STREAM_CHANGE - Signals that the current subpicture stream number changed for the main title.';
      EC_DVD_TITLE_CHANGE              : result:= 'EC_DVD_TITLE_CHANGE - Indicates when the current title number changes.';
      EC_DVD_VALID_UOPS_CHANGE         : result:= 'EC_DVD_VALID_UOPS_CHANGE - Signals that the available set of IDVDControl2 interface methods has changed.';
      EC_DVD_WARNING                   : result:= 'EC_DVD_WARNING - Signals a DVD warning condition.'
    else
      result := 'Unknow Graph Event!';
    end;
  end;

  function IntToBin(Value: LongInt; Digits: Integer): String;
  var
   i: Integer;
  begin
   Result:='';
   for i:=Digits downto 0 do
    if Value and (1 shl i)<>0 then
     Result:=Result + '1'
    else
     Result:=Result + '0';
  end;

   function IntToUOPS(value : longint):TUOPS;
  var temp : string;
  begin
    temp := inttobin(value,24);
  with result do
  begin
     TitlePlay                          := (copy(temp,3,1)='1'); //2
     ChapterPlay                        := (copy(temp,2,1)='1'); //1
     TimePlay                           := (copy(temp,1,1)='1'); //0
     StopForResume                      := (copy(temp,4,1)='1'); //3
     GoUp                               := (copy(temp,5,1)='1'); //4
     TimeSearch                         := (copy(temp,1,1)='1')and(copy(temp,6,1)='1'); //0,5
     ChapterSearch                      := (copy(temp,2,1)='1')and(copy(temp,6,1)='1'); //1,5
     PrevPGSearch                       := (copy(temp,7,1)='1'); //6
     TopPGSearch                        := (copy(temp,7,1)='1'); //6
     NextPGSearch                       := (copy(temp,8,1)='1'); //7
     ForwardScan                        := (copy(temp,9,1)='1'); //8
     BackwardScan                       := (copy(temp,10,1)='1'); //9
     MenuCall_Title_Menu                := (copy(temp,11,1)='1'); //10
     MenuCall_Root_Menu                 := (copy(temp,12,1)='1'); //11
     MenuCall_Sub_picture_Menu          := (copy(temp,13,1)='1'); //12
     MenuCall_Audio_Menu                := (copy(temp,14,1)='1'); //13
     MenuCall_Angle_Menu                := (copy(temp,15,1)='1'); //14
     MenuCall_Chapter_Menu              := (copy(temp,16,1)='1'); //15
     Resume                             := (copy(temp,17,1)='1'); //16
     UpperButtonSelect                  := (copy(temp,18,1)='1'); //17
     LowerButtonSelect                  := (copy(temp,18,1)='1'); //17
     LeftButtonSelect                   := (copy(temp,18,1)='1'); //17
     RightButtonSelect                  := (copy(temp,18,1)='1'); //17
     ButtonActivate                     := (copy(temp,18,1)='1'); //17
     ButtonSelectAndActivate            := (copy(temp,18,1)='1'); //17
     StillOff                           := (copy(temp,19,1)='1'); //18
     PauseOn                            := (copy(temp,20,1)='1'); //19
     PauseOff                           := (copy(temp,20,1)='1'); //19
     AudioStreamChange                  := (copy(temp,21,1)='1'); //20
     SubpictureStreamChange             := (copy(temp,22,1)='1'); //21
     AngleChange                        := (copy(temp,23,1)='1'); //22
     KaraokeAudioPresentationModeChange := (copy(temp,24,1)='1'); //23
     VideoModePreferrence               := (copy(temp,25,1)='1'); //24
  end;
  end;

  function IntToTimeCode(x : longint): TDVD_TimeCode;
  var
     tc : TDVD_TimeCode;
     str: string;
  begin
    str := IntToBin(x,31);
    tc.Hours1        := bintoint(copy(str,29,4));
    tc.Hours10       := bintoint(copy(str,25,4));
    tc.Minutes1      := bintoint(copy(str,21,4));
    tc.Minutes10     := bintoint(copy(str,17,4));
    tc.Seconds1      := bintoint(copy(str,13,4));
    tc.Seconds10     := bintoint(copy(str,9,4));
    tc.Frames1       := bintoint(copy(str,5,4));
    tc.Frames10      := bintoint(copy(str,3,2));
    tc.FrameRateCode := bintoint(copy(str,1,2));
    result := tc;
end;

  function BinToInt(Value: String): LongInt;
  var
     i,Digits: Integer;
     p : array[0..3]of integer;
  begin
     Result:=0;
     p[0]:=1;p[1]:=2;p[2]:=4;p[3]:=8;
     Digits:=Length(Value);
     for i := 1 to digits do
       begin
         if copy(value,i,1) = '1' then result := result+p[digits-i];
       end;
  end;

  function TimeCodeToFrames(value : TDVD_TimeCode): ULONG;
  var
    frate : ULONG;
  begin
    case value.FrameRateCode of
      1 : frate := 25;
      3 : frate := 30;
    else
      frate := 0;
    end;
    result := ((value.Hours1+value.Hours10*10)*3600   +
               (value.Minutes1+value.Minutes10*10)*60 +
                value.Seconds1+value.Seconds10*10)*
                frate+value.Frames1+value.Frames10*10;
  end;

  function ShowFilterPropertyPage(parent: TWinControl; Filter: IBaseFilter): HRESULT;
  var
    SpecifyPropertyPages : ISpecifyPropertyPages;
    CAGUID  :TCAGUID;
    FilterInfo: TFilterInfo;
  begin
    result := S_FALSE;
    if Filter = nil then exit;
    result := Filter.QueryInterface(IID_ISpecifyPropertyPages, SpecifyPropertyPages);
    if result <> S_OK then exit;
    result := SpecifyPropertyPages.GetPages(CAGUID);
    if result <> S_OK then exit;
    result := Filter.QueryFilterInfo(FilterInfo);
    if result <> S_OK then exit;
    if parent <> nil then
      result := OleCreatePropertyFrame(parent.Handle, 0, 0, FilterInfo.achName, 1, @Filter, CAGUID.cElems, CAGUID.pElems, 0, 0, nil )
    else
      result := OleCreatePropertyFrame(0, 0, 0, FilterInfo.achName, 1, @Filter, CAGUID.cElems, CAGUID.pElems, 0, 0, nil );
  end;

  function ShowPinPropertyPage(parent: TWinControl; Pin: IPin): HRESULT;
  var
    SpecifyPropertyPages: ISpecifyPropertyPages;
    CAGUID :TCAGUID;
    PinInfo: TPin_Info;
  begin
    result := S_FALSE;
    if Pin = nil then exit;
    result := Pin.QueryInterface(IID_ISpecifyPropertyPages, SpecifyPropertyPages);
    if result <> S_OK then exit;
    result := SpecifyPropertyPages.GetPages(CAGUID);
    if result <> S_OK then exit;
    result := Pin.QueryPinInfo(PinInfo);
    if result <> S_OK then exit;
    if parent <> nil then
      result := OleCreatePropertyFrame(parent.Handle, 0, 0, PinInfo.achName, 1, @Pin, CAGUID.cElems, CAGUID.pElems, 0, 0, nil )
    else
      result := OleCreatePropertyFrame(0, 0, 0, PinInfo.achName, 1, @Pin, CAGUID.cElems, CAGUID.pElems, 0, 0, nil );
  end;

  //----------------------------------------------------------------------------
  // Enable Graphedit to connect with your filter graph
  //----------------------------------------------------------------------------
  function AddGraphToRot(Graph: IFilterGraph; out dwRegister: Longint): HRESULT;
  var
    Moniker: IMoniker;
    ROT    : IRunningObjectTable;
    wsz    : string[255];
  begin
    result := GetRunningObjectTable(0, ROT);
    if (result <> S_OK) then exit;
    wsz := format('FilterGraph %p pid %x',[pointer(graph),GetCurrentProcessId()]);
    result  := CreateItemMoniker('!', StringToOleStr(wsz), Moniker);
    if (result <> S_OK) then exit;
    result  := ROT.Register(0, Graph, Moniker, dwRegister);
  end;

  //----------------------------------------------------------------------------
  // Disable Graphedit to connect with your filter graph
  //----------------------------------------------------------------------------
  function RemoveGraphFromRot(dwRegister: longint): HRESULT;
  var ROT: IRunningObjectTable;
  begin
    result := GetRunningObjectTable(0, ROT);
    if (result <> S_OK) then exit;
    result := ROT.Revoke(dwRegister);
  end;

  function GetErrorString(hr: HRESULT): string;
  var buffer: array[0..254] of char;
  begin
    AMGetErrorTextA(hr,@buffer,255);
    result := buffer;
  end;

  // general purpose function to delete a heap allocated AM_MEDIA_TYPE structure
  // which is useful when calling IEnumMediaTypes::Next as the interface
  // implementation allocates the structures which you must later delete
  // the format block may also be a pointer to an interface to release
  procedure DeleteMediaType(pmt: PAM_MEDIA_TYPE);
  begin
    // allow nil pointers for coding simplicity
    if (pmt = nil) then exit;
    FreeMediaType(pmt);
    CoTaskMemFree(pmt);
  end;

  // this also comes in useful when using the IEnumMediaTypes interface so
  // that you can copy a media type, you can do nearly the same by creating
  // a CMediaType object but as soon as it goes out of scope the destructor
  // will delete the memory it allocated (this takes a copy of the memory)
  function  CreateMediaType(pSrc: PAM_MEDIA_TYPE): PAM_MEDIA_TYPE;
  var pMediaType: PAM_MEDIA_TYPE;
  begin
    ASSERT(pSrc<>nil);

    // Allocate a block of memory for the media type
    pMediaType := CoTaskMemAlloc(sizeof(TAM_MEDIA_TYPE));
    if (pMediaType = nil) then
    begin
      result := nil;
      exit;
    end;

    // Copy the variable length format block
    CopyMediaType(pMediaType,pSrc);
    result := pMediaType;
  end;

  //----------------------------------------------------------------------------
  // Copies a task-allocated AM_MEDIA_TYPE structure.
  //----------------------------------------------------------------------------
  procedure CopyMediaType(pmtTarget: PAM_MEDIA_TYPE; pmtSource: PAM_MEDIA_TYPE);
  begin
    //  We'll leak if we copy onto one that already exists - there's one
    //  case we can check like that - copying to itself.
    ASSERT(pmtSource <> pmtTarget);
    pmtTarget^ := pmtSource^;
    if (pmtSource.cbFormat <> 0) then
    begin
      ASSERT(pmtSource.pbFormat <> nil);
      pmtTarget.pbFormat := CoTaskMemAlloc(pmtSource.cbFormat);
      if (pmtTarget.pbFormat = nil) then
        pmtTarget.cbFormat := 0
      else
        CopyMemory(pmtTarget.pbFormat, pmtSource.pbFormat, pmtTarget.cbFormat);
    end;
    if (pmtTarget.pUnk <> nil) then  pmtTarget.pUnk._AddRef;
  end;

  procedure FreeMediaType(mt: PAM_MEDIA_TYPE);
  begin
    if (mt^.cbFormat <> 0) then
    begin
      CoTaskMemFree(mt^.pbFormat);
      // Strictly unnecessary but tidier
      mt^.cbFormat := 0;
      mt^.pbFormat := nil;
    end;
    if (mt^.pUnk <> nil) then mt^.pUnk := nil;
  end;

  //----------------------------------------------------------------------------
  //  Initializes a media type structure given a wave format structure.
  //----------------------------------------------------------------------------
  function CreateAudioMediaType(pwfx: PWaveFormatEx; pmt: PAM_MEDIA_TYPE; bSetFormat: boolean): HRESULT;
  begin
    pmt.majortype := MEDIATYPE_Audio;
    if (pwfx.wFormatTag = WAVE_FORMAT_EXTENSIBLE) then
      pmt.subtype := PWAVEFORMATEXTENSIBLE(pwfx).SubFormat
    else
      pmt.subtype := FOURCCMap(pwfx.wFormatTag);
    pmt.formattype           := FORMAT_WaveFormatEx;
    pmt.bFixedSizeSamples    := TRUE;
    pmt.bTemporalCompression := FALSE;
    pmt.lSampleSize          := pwfx.nBlockAlign;
    pmt.pUnk                 := nil;
    if (bSetFormat) then
    begin
      if (pwfx.wFormatTag = WAVE_FORMAT_PCM) then
        pmt.cbFormat := sizeof(TWAVEFORMATEX)
      else
        pmt.cbFormat := sizeof(TWAVEFORMATEX) + pwfx.cbSize;
      pmt.pbFormat := CoTaskMemAlloc(pmt.cbFormat);
      if (pmt.pbFormat = nil) then
      begin
        result := E_OUTOFMEMORY;
        exit;
      end;
      if (pwfx.wFormatTag = WAVE_FORMAT_PCM) then
      begin
        CopyMemory(pmt.pbFormat, pwfx, sizeof(PCMWAVEFORMAT));
        PWAVEFORMATEX(pmt.pbFormat).cbSize := 0;
      end
      else
      begin
        CopyMemory(pmt.pbFormat, pwfx, pmt.cbFormat);
      end;
    end;
    result := S_OK;
  end;

  //XXXXXXXX-0000-0010-8000-00AA00389B71
  function  FOURCCMap(Fourcc: DWORD): TGUID;
  const tmpguid : TGUID = '{00000000-0000-0010-8000-00AA00389B71}';
  begin
    result := tmpguid;
    result.D1 := Fourcc;
  end;

  // trouve les 4 carracteres qui identifient le codec utilis
  // find the 4 Characters Codes wich identifi codec used
  function GetFOURCC(FOURCC: DWORD): string;
  type TFOURCC= array[0..3] of char;
  var  CC: TFOURCC;
  begin
    case FOURCC of
      0 : result := 'RGB';
      1 : result := 'RLE8';
      2 : result := 'RLE4';
      3 : result := 'BITFIELDS';   
    else
      PDWORD(@CC)^ := FOURCC; // abracadabra
      result := CC;
    end;
  end;

  //----------------------------------------------------------------------------
  // Donne une brve description du Media Type
  // Give a short Media Type description
  // Tell me if you find not listed media type
  //----------------------------------------------------------------------------
  function GetMediaTypeDescription(MediaType: TAM_Media_Type): string;
  begin
    // major types
    result := 'Major Type: ';
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_AnalogAudio)   then result := result+'AnalogAudio'   else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_AnalogVideo)   then result := result+'Analogvideo'   else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Audio)         then result := result+'Audio'         else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_AUXLine21Data) then result := result+'AUXLine21Data' else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_File)          then result := result+'File'          else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Interleaved)   then result := result+'Interleaved'   else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_LMRT)          then result := result+'LMRT'          else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Midi)          then result := result+'Midi'          else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_MPEG2_PES)     then result := result+'MPEG2_PES'     else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_ScriptCommand) then result := result+'ScriptCommand' else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Stream)        then result := result+'Stream'        else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Text)          then result := result+'Text'          else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Timecode)      then result := result+'Timecode'      else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_URL_STREAM)    then result := result+'URL_STREAM'    else
    if IsEqualGUID(MediaType.majortype,MEDIATYPE_Video)         then result := result+'Video'         else
       result := result+'UnKnown ';
    // sub types
    result := result + ' - Sub Type: ';
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_CLPL) then result := result+'CLPL' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_YUYV) then result := result+'YUYV' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_IYUV) then result := result+'IYUV' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_YVU9) then result := result+'YVU9' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Y411) then result := result+'Y411' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Y41P) then result := result+'Y41P' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_YUY2) then result := result+'YUY2' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_YVYU) then result := result+'YVYU' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_UYVY) then result := result+'UYVY' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Y211) then result := result+'Y211' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_YV12) then result := result+'YV12' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_CLJR) then result := result+'CLJR' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_IF09) then result := result+'IF09' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_CPLA) then result := result+'CPLA' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MJPG) then result := result+'MJPG' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_TVMJ) then result := result+'TVMJ' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_WAKE) then result := result+'WAKE' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_CFCC) then result := result+'CFCC' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_IJPG) then result := result+'IJPG' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Plum) then result := result+'Plum' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVCS) then result := result+'DVCS' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVSD) then result := result+'DVSD' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MDVF) then result := result+'MDVF' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB1) then result := result+'RGB1' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB4) then result := result+'RGB4' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB8) then result := result+'RGB8' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB565) then result := result+'RGB565' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB555) then result := result+'RGB555' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB24) then result := result+'RGB24' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RGB32) then result := result+'RGB32' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_ARGB32) then result := result+'ARGB32' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Overlay) then result := result+'Overlay' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1Packet) then result := result+'MPEG1Packet' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1Payload) then result := result+'MPEG1Payload' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1AudioPayload) then result := result+'MPEG1AudioPayload' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1System) then result := result+'MPEG1System' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1VideoCD) then result := result+'MPEG1VideoCD' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1Video) then result := result+'MPEG1Video' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG1Audio) then result := result+'MPEG1Audio' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Avi) then result := result+'Avi' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Asf) then result := result+'Asf' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_QTMovie) then result := result+'QTMovie' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_QTRpza) then result := result+'QTRpza' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_QTSmc) then result := result+'QTSmc' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_QTRle) then result := result+'QTRle' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_QTJpeg) then result := result+'QTJpeg' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_PCMAudio_Obsolete) then result := result+'PCMAudio_Obsolete' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_PCM) then result := result+'PCM' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_WAVE) then result := result+'WAVE' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AU) then result := result+'AU' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AIFF) then result := result+'AIFF' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_dvsd_) then result := result+'dvsd_' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_dvhd) then result := result+'dvhd' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_dvsl) then result := result+'dvsl' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Line21_BytePair) then result := result+'Line21_BytePair' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Line21_GOPPacket) then result := result+'Line21_GOPPacket' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_Line21_VBIRawData) then result := result+'Line21_VBIRawData' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DRM_Audio) then result := result+'DRM_Audio' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_IEEE_FLOAT) then result := result+'IEEE_FLOAT' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DOLBY_AC3_SPDIF) then result := result+'DOLBY_AC3_SPDIF' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_RAW_SPORT) then result := result+'RAW_SPORT' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_SPDIF_TAG_241h) then result := result+'SPDIF_TAG_241h' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DssVideo) then result := result+'DssVideo' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DssAudio) then result := result+'DssAudio' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_VPVideo) then result := result+'VPVideo' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_VPVBI) then result := result+'VPVBI' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_NTSC_M) then result := result+'AnalogVideo_NTSC_M' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_B) then result := result+'AnalogVideo_PAL_B' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_D) then result := result+'AnalogVideo_PAL_D' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_G) then result := result+'AnalogVideo_PAL_G' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_H) then result := result+'AnalogVideo_PAL_H' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_I) then result := result+'AnalogVideo_PAL_I' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_M) then result := result+'AnalogVideo_PAL_M' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_N) then result := result+'AnalogVideo_PAL_N' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_PAL_N_COMBO) then result := result+'AnalogVideo_PAL_N_COMBO' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_B) then result := result+'AnalogVideo_SECAM_B' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_D) then result := result+'AnalogVideo_SECAM_D' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_G) then result := result+'AnalogVideo_SECAM_G' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_H) then result := result+'AnalogVideo_SECAM_H' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_K) then result := result+'AnalogVideo_SECAM_K' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_K1) then result := result+'AnalogVideo_SECAM_K1' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_AnalogVideo_SECAM_L) then result := result+'AnalogVideo_SECAM_L' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG2_VIDEO) then result := result+'MPEG2_VIDEO' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG2_PROGRAM) then result := result+'MPEG2_PROGRAM' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG2_TRANSPORT) then result := result+'MPEG2_TRANSPORT' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MPEG2_AUDIO) then result := result+'MPEG2_AUDIO' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DOLBY_AC3) then result := result+'DOLBY_AC3' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVD_SUBPICTURE) then result := result+'DVD_SUBPICTURE' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVD_LPCM_AUDIO) then result := result+'DVD_LPCM_AUDIO' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DTS) then result := result+'DTS' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_SDDS) then result := result+'SDDS' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVD_NAVIGATION_PCI) then result := result+'PCI' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVD_NAVIGATION_DSI) then result := result+'DSI' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DVD_NAVIGATION_PROVIDER) then result := result+'PROVIDER' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_MP42) then result := result+'MS-MPEG4' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_DIVX) then result := result+'DIVX' else
    if IsEqualGUID(MediaType.subtype,MEDIASUBTYPE_VOXWARE) then result := result+'VOXWARE_MetaSound' else
       result := result+'UnKnown ';

  // format
    result := result+ ' Format: ';
    if IsEqualGUID(MediaType.formattype,FORMAT_VideoInfo) then
    begin
      result := result+'VideoInfo ';
      if ((MediaType.cbFormat > 0) and assigned(MediaType.pbFormat)) then
      with PVideoInfoHeader(MediaType.pbFormat)^.bmiHeader do
      result := result + format('%s %dX%d, %d bits',
        [GetFOURCC(biCompression), biWidth, biHeight, biBitCount]);
    end
    else
    begin
      if IsEqualGUID(MediaType.formattype,FORMAT_VideoInfo2) then
      begin
        result := result+'VideoInfo2 ';
        if ((MediaType.cbFormat > 0) and assigned(MediaType.pbFormat)) then
        with PVideoInfoHeader2(MediaType.pbFormat)^.bmiHeader do
        result := result + format('%s %dX%d, %d bits',
          [GetFOURCC(biCompression), biWidth, biHeight, biBitCount]);
      end
      else
      begin
        if IsEqualGUID(MediaType.formattype,FORMAT_WaveFormatEx) then
        begin
          result := result+'WaveFormatEx: ';
          if ((MediaType.cbFormat > 0) and assigned(MediaType.pbFormat)) then
          case PWaveFormatEx(MediaType.pbFormat)^.wFormatTag of
            $0001: result := result+'PCM';  // common
            $0002: result := result+'ADPCM';
            $0003: result := result+'IEEE_FLOAT';
            $0005: result := result+'IBM_CVSD';
            $0006: result := result+'ALAW';
            $0007: result := result+'MULAW';
            $0010: result := result+'OKI_ADPCM';
            $0011: result := result+'DVI_ADPCM';
            $0012: result := result+'MEDIASPACE_ADPCM';
            $0013: result := result+'SIERRA_ADPCM';
            $0014: result := result+'G723_ADPCM';
            $0015: result := result+'DIGISTD';
            $0016: result := result+'DIGIFIX';
            $0017: result := result+'DIALOGIC_OKI_ADPCM';
            $0018: result := result+'MEDIAVISION_ADPCM';
            $0020: result := result+'YAMAHA_ADPCM';
            $0021: result := result+'SONARC';
            $0022: result := result+'DSPGROUP_TRUESPEECH';
            $0023: result := result+'ECHOSC1';
            $0024: result := result+'AUDIOFILE_AF36';
            $0025: result := result+'APTX';
            $0026: result := result+'AUDIOFILE_AF10';
            $0030: result := result+'DOLBY_AC2';
            $0031: result := result+'GSM610';
            $0032: result := result+'MSNAUDIO';
            $0033: result := result+'ANTEX_ADPCME';
            $0034: result := result+'CONTROL_RES_VQLPC';
            $0035: result := result+'DIGIREAL';
            $0036: result := result+'DIGIADPCM';
            $0037: result := result+'CONTROL_RES_CR10';
            $0038: result := result+'NMS_VBXADPCM';
            $0039: result := result+'CS_IMAADPCM';
            $003A: result := result+'ECHOSC3';
            $003B: result := result+'ROCKWELL_ADPCM';
            $003C: result := result+'ROCKWELL_DIGITALK';
            $003D: result := result+'XEBEC';
            $0040: result := result+'G721_ADPCM';
            $0041: result := result+'G728_CELP';
            $0050: result := result+'MPEG';
            $0055: result := result+'MPEGLAYER3';
            $0060: result := result+'CIRRUS';
            $0061: result := result+'ESPCM';
            $0062: result := result+'VOXWARE';
            $0063: result := result+'CANOPUS_ATRAC';
            $0064: result := result+'G726_ADPCM';
            $0065: result := result+'G722_ADPCM';
            $0066: result := result+'DSAT';
            $0067: result := result+'DSAT_DISPLAY';
            $0075: result := result+'VOXWARE'; // aditionnal  ???
            $0080: result := result+'SOFTSOUND';
            $0100: result := result+'RHETOREX_ADPCM';
            $0200: result := result+'CREATIVE_ADPCM';
            $0202: result := result+'CREATIVE_FASTSPEECH8';
            $0203: result := result+'CREATIVE_FASTSPEECH10';
            $0220: result := result+'QUARTERDECK';
            $0300: result := result+'FM_TOWNS_SND';
            $0400: result := result+'BTV_DIGITAL';
            $1000: result := result+'OLIGSM';
            $1001: result := result+'OLIADPCM';
            $1002: result := result+'OLICELP';
            $1003: result := result+'OLISBC';
            $1004: result := result+'OLIOPR';
            $1100: result := result+'LH_CODEC';
            $1400: result := result+'NORRIS';
          else
            result := result+'Unknown';
          end;

          with PWaveFormatEx(MediaType.pbFormat)^ do
          result := result + format(', %d Hertz, %d Bits, %d Channels',
            [nSamplesPerSec, cbSize, nChannels]);

        end
        else
        begin
          if IsEqualGUID(MediaType.formattype,FORMAT_MPEGVideo) then
          begin
            result := result+'MPEGVideo ';
            if ((MediaType.cbFormat > 0) and assigned(MediaType.pbFormat)) then
            with PMPEG1VIDEOINFO(MediaType.pbFormat)^.hdr.bmiHeader do
              result := result + format('%s %dX%d, %d bits',
              [GetFOURCC(biCompression), biWidth, biHeight, biBitCount]);

          end
          else
          begin
            if IsEqualGUID(MediaType.formattype,FORMAT_MPEG2Video) then
            begin
              result := result+'MPEGStreams ';
              if ((MediaType.cbFormat > 0) and assigned(MediaType.pbFormat)) then
              with PMPEG2VIDEOINFO(MediaType.pbFormat)^.hdr.bmiHeader do
                result := result + format('%s %dX%d, %d bits',
                [GetFOURCC(biCompression), biWidth, biHeight, biBitCount]);
            end
            else
            begin  // todo
              if IsEqualGUID(MediaType.formattype,FORMAT_DvInfo)        then result := result+'DvInfo' else
              if IsEqualGUID(MediaType.formattype,FORMAT_MPEGStreams)   then result := result+'MPEGStreams' else
              if IsEqualGUID(MediaType.formattype,FORMAT_DolbyAC3)      then result := result+'DolbyAC3' else
              if IsEqualGUID(MediaType.formattype,FORMAT_MPEG2Audio)    then result := result+'MPEG2Audio' else
              if IsEqualGUID(MediaType.formattype,FORMAT_DVD_LPCMAudio) then result := result+'DVD_LPCMAudio' else
                result := result+'Unknown';
            end;
          end;
        end;
      end;
    end;
  end;

  procedure FreeAndNil(var Obj);
  var
    Temp: TObject;
  begin
    Temp := TObject(Obj);
    Pointer(Obj) := nil;
    Temp.Free;
  end;

  function MAKEFOURCC(ch0, ch1, ch2, ch3: char): DWORD;
  begin
    result := DWORD(BYTE(ch0)) or
    (DWORD(BYTE(ch1)) shl 8)   or
    (DWORD(BYTE(ch2)) shl 16)  or
    (DWORD(BYTE(ch3)) shl 24)
  end;

  // Functions to save and restor pesistent objects

  function PersistToHex(obj: IPersistStream): string;
  var
    MemStream : TMemoryStream;
    AdaStream : TStreamAdapter;
    dest      : pchar;
    size      : integer;
  begin
    if assigned(obj) then
    begin
      MemStream := TMemoryStream.Create;
      AdaStream := TStreamAdapter.Create(MemStream, soReference);
      OleSaveToStream(obj, AdaStream);
      size := MemStream.Size;
      getmem(dest, (Size*2)+1);
      zeromemory(dest, (Size*2)+1);
      bintohex(MemStream.Memory, dest, Size);
      result := dest;
      freemem(dest, (Size*2)+1);
      AdaStream.Free;
      MemStream.Free;
    end
    else
      result := '';
  end;

  function HexToPersist(str: String; GUID: TGUID): IPersistStream;
  var
    MemStream : TMemoryStream;
    AdaStream : TStreamAdapter;
    size      : integer;
  begin
    MemStream := TMemoryStream.Create;
    AdaStream := TStreamAdapter.Create(MemStream, soReference);
    size := length(str) div 2;
    MemStream.SetSize(size);
    HexToBin(pchar(str), MemStream.Memory, size);
    OleLoadFromStream(AdaStream, GUID, result);
    AdaStream.Free;
    MemStream.Free;
  end;

end.
