unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DSFilters, StdCtrls, OleServer, dspack, directshow, dsutil, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBoxFilter: TListBox;
    DSVideoWindow1: TDSVideoWindow;
    FilterGraph: TDSFilterGraph2;
    Button1: TButton;
    Button2: TButton;
    PinList: TListBox;
    MediaList: TListBox;
    Image1: TImage;
    grabber: TFilterSampleGrabber;
    CheckBox1: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListBoxFilterClick(Sender: TObject);
    procedure PinListClick(Sender: TObject);
    procedure MediaListDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure grabberBuffer(sender: TComponent; Buffer: TBufferCB);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 : TForm1;
  wdm   : TFilterWDMVideoCapture;
  EnumMT: TDSEnumMediaType;
  //grabber: TFilterSampleGrabber;
implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var i: integer;
begin
  wdm := TFilterWDMVideoCapture.Create(nil);
  for i := 0 to wdm.Count-1 do
    ListBoxFilter.Items.Add(wdm.DeviceName[i]);
  EnumMT := TDSEnumMediaType.Create;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //if assigned(grabber) then grabber.Free;
  EnumMT.Free;
  FilterGraph.Disconnect;
  wdm.Free;
end;

procedure TForm1.ListBoxFilterClick(Sender: TObject);
var i: integer;
begin
  if ListBoxFilter.ItemIndex <> -1 then
  begin
    FilterGraph.ClearGraph;
    button1.Enabled := false;
    button2.Enabled := false;
    //if assigned(grabber) then grabber.Free;
    //grabber := TFilterSampleGrabber.Create;
    wdm.SelectDevice(ListBoxFilter.ItemIndex);
    FilterGraph.FilterGraph2.AddFilter(wdm.BaseFilter,stringtoolestr(wdm.DeviceName[ListBoxFilter.ItemIndex]));
    FilterGraph.FilterGraph2.AddFilter(grabber.BaseFilter,'Sample Grabber');
    PinList.Clear;
    MediaList.Clear;
    if wdm.Pins.Count > 0 then
    for i := 0 to wdm.pins.Count-1  do
      PinList.Items.Add(wdm.Pins.PinInfo[i].achName);
  end;
end;

procedure TForm1.PinListClick(Sender: TObject);
var i: integer;
begin
  if PinList.ItemIndex >= 0 then
  begin
    MediaList.Clear;
    EnumMT.Assign(wdm.Pins.Items[PinList.ItemIndex]);
    if EnumMT.Count > 0 then
      for i := 0 to EnumMT.Count -1 do
      MediaList.Items.Add(GetMediaTypeDescription(EnumMT.Items[i].AMMediaType^));

  end;
end;

procedure TForm1.MediaListDblClick(Sender: TObject);
var StreamConfig: IAMStreamConfig;
begin
  if MediaList.ItemIndex >= 0 then
  begin
    wdm.Pins.Items[PinList.ItemIndex].QueryInterface(IID_IAMStreamConfig,StreamConfig);
    StreamConfig.SetFormat(EnumMT.Items[MediaList.ItemIndex].AMMediaType^);
    grabber.SetBMPCompatible(EnumMT.Items[MediaList.ItemIndex].AMMediaType,24);
    StreamConfig := nil;
    PinListClick(self);
    button1.Enabled := true;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FilterGraph.FilterGraph2.Render(wdm.Pins.Items[PinList.ItemIndex]);
  FilterGraph.QueryInterfaces;
  FilterGraph.MediaControl.Run;
  button2.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  grabber.GetBitmap(image1.Picture.Bitmap);
end;

procedure TForm1.grabberBuffer(sender: TComponent; Buffer: TBufferCB);
begin
  if checkbox1.Checked then grabber.GetBitmap(image1.Picture.Bitmap, buffer);
end;

end.
